Index: trunk/VUT/work/ogre_changes/RenderSystems/GL/src/OgreGLHardwareOcclusionQuery.cpp
===================================================================
--- trunk/VUT/work/ogre_changes/RenderSystems/GL/src/OgreGLHardwareOcclusionQuery.cpp	(revision 99)
+++ trunk/VUT/work/ogre_changes/RenderSystems/GL/src/OgreGLHardwareOcclusionQuery.cpp	(revision 115)
@@ -27,7 +27,6 @@
 #include "OgreException.h"
 
+
 namespace Ogre {
-
-int GLHardwareOcclusionQuery::m_Skip = 0;
 
 /**
@@ -36,19 +35,9 @@
   *
   * @author Lee Sandberg email: lee@abcmedia.se
+  *
+  * Updated on 12/7/2004 by Chris McGuirk
+  * - Implemented ARB_occlusion_query
   */
 
-/* Functions used;
-
-glGenOcclusionQueriesNV_ptr( 1, m_uintQuery );
-glDeleteOcclusionQueriesNV_ptr( 1, &m_uintQuery[0] );
-glBeginOcclusionQueryNV_ptr( m_uintQuery[0] );
-glEndOcclusionQueryNV_ptr();
-glGetOcclusionQueryuivNV_ptr( m_uintQuery[0], GL_PIXEL_COUNT_NV, NumOfFragments );
-
-  TO DO: change this to the new ARB functions...
-
-*/
-
-#ifndef GTP_VISIBILITY_MODIFIED_OGRE
 /**
   * Default object constructor
@@ -57,23 +46,26 @@
 GLHardwareOcclusionQuery::GLHardwareOcclusionQuery() 
 { 
-	m_uintPixelCount = 0; 
-	m_SkipCounter = 0;
+	mPixelCount = 0; 
+	mSkipCounter = 0;
+	mSkipInterval = 0;
 
 	// Check for hardware occlusion support
-    if( glDeleteOcclusionQueriesNV_ptr != 0 )	// This is a hack to see if hw occlusion is supported. pointer is 0 if it's not supported.
+	// This is a hack to see if hw occlusion is supported. pointer is 0 if it's not supported.
+	//if (glGenQueriesARB_ptr != 0)
+	if (glGenOcclusionQueriesNV_ptr != 0)
     {
-		m_bHWOcclusionSupport = true;
+		mHasOcclusionSupport = true;
 	}
 	else
 	{
-		m_bHWOcclusionSupport = false;
+		mHasOcclusionSupport = false;
 	}
 
-	if( m_bHWOcclusionSupport )
+	if(mHasOcclusionSupport)
 	{
-		glGenOcclusionQueriesNV_ptr( 1, m_uintQuery );	
+		//glGenQueriesARB_ptr(1, &mQueryID );	
+		glGenOcclusionQueriesNV_ptr(1, &mQueryID);
 	}
 }
-
 
 /**
@@ -82,7 +74,8 @@
 GLHardwareOcclusionQuery::~GLHardwareOcclusionQuery() 
 { 
-	if( m_bHWOcclusionSupport )
+	if( mHasOcclusionSupport )
 	{
-		glDeleteOcclusionQueriesNV_ptr( 1, &m_uintQuery[0] );  
+		//glDeleteQueriesARB_ptr(1, &mQueryID);  
+		glDeleteOcclusionQueriesNV_ptr(1, &mQueryID);  
 	}	
 }
@@ -93,10 +86,21 @@
 void GLHardwareOcclusionQuery::beginOcclusionQuery() 
 { 
-	if( m_bHWOcclusionSupport )	// Make it fail silently if hardware occlusion isn't supported
+	// Make it fail silently if hardware occlusion isn't supported
+	if(mHasOcclusionSupport)
 	{
-		if  ( m_SkipCounter ==  m_Skip ) { m_SkipCounter = 0; };		// Counter starts at 0 again at m_Skip 
-		if ( m_SkipCounter == 0 && m_uintPixelCount != 0 ) // New or none visable objects must allways be tested but visable objects can be skiped
+		// Counter starts at 0 again at mSkipInterval 
+#ifndef GTP_VISIBILITY_MODIFIED_OGRE
+		if(mSkipCounter == mSkipInterval) 
+#else
+		if (mSkipCounter >= mSkipInterval)  // otherwise no query ever issued if mSkipInterval = 0 !
+#endif // GTP_VISIBILITY_MODIFIED_OGRE
+	{
+			mSkipCounter = 0; 
+		}
+
+		if (mSkipCounter == 0)
 		{
-			glBeginOcclusionQueryNV_ptr( m_uintQuery[0] );
+			//glBeginQueryARB_ptr(GL_SAMPLES_PASSED_ARB, mQueryID);
+			glBeginOcclusionQueryNV_ptr(mQueryID);
 		}
 	}
@@ -105,40 +109,26 @@
 void GLHardwareOcclusionQuery::endOcclusionQuery() 
 { 
-	if( m_bHWOcclusionSupport )	// Make it fail silently if hardware occlusion isn't supported
+	// Make it fail silently if hardware occlusion isn't supported
+	if(mHasOcclusionSupport)
 	{
-		if( m_SkipCounter == 0 && m_uintPixelCount != 0 ) // New or none visable objects must allways be tested but visable objects can be skiped
+		if( mSkipCounter == 0)
 		{
+			//glEndQueryARB_ptr(GL_SAMPLES_PASSED_ARB);
 			glEndOcclusionQueryNV_ptr();
 		}
-		m_SkipCounter++;
-	}
-}
 
-bool GLHardwareOcclusionQuery::pullOcclusionQuery( unsigned int * NumOfFragments) 
-{
-	if( m_bHWOcclusionSupport )	// Make it fail silently if hardware occlusion isn't supported
-	{
-		glGetOcclusionQueryuivNV_ptr( m_uintQuery[0], GL_PIXEL_COUNT_NV, NumOfFragments );
+		mSkipCounter++;
 	} 
-	else
-	{
-		*NumOfFragments = 100000;		// Fails quitlly -> every object tested is visable.
-	}
-
-	m_uintPixelCount = *NumOfFragments; 
-
-	return true;
 }
 
 //------------------------------------------------------------------
-// OpenGL dosn't use the flag, but to fulfil the abstract interface we need to include this function.
-// Using this function in OpenGL mode simple works the same way as calling the other function without the flag parameter,
-// but in DX9 it works differentlly, see notes in the DX9 implementation.
-//--
+// OpenGL dosn't use the flag paramter.
+//------------------------------------------------------------------
 bool GLHardwareOcclusionQuery::pullOcclusionQuery( unsigned int* NumOfFragments, const HW_OCCLUSIONQUERY flag  ) 
 {
-	if( m_bHWOcclusionSupport )	// Make it fail silently if hardware occlusion isn't supported
+	if( mHasOcclusionSupport )	// Make it fail silently if hardware occlusion isn't supported
 	{
-		glGetOcclusionQueryuivNV_ptr( m_uintQuery[0], GL_PIXEL_COUNT_NV, NumOfFragments );
+		//glGetQueryObjectuivARB_ptr(mQueryID, GL_QUERY_RESULT_ARB, NumOfFragments);
+glGetOcclusionQueryuivNV_ptr(mQueryID, GL_PIXEL_COUNT_NV, NumOfFragments);
 	}
 	else
@@ -147,83 +137,28 @@
 	}
 
-	m_uintPixelCount = *NumOfFragments; 
+	mPixelCount = *NumOfFragments; 
 	
 	return true;
 }
 
-#else // GTP_VISIBILITY_MODIFIED_OGRE
-
-//------------------------------------------------------------------
-GLHardwareOcclusionQuery::GLHardwareOcclusionQuery() 
-{ 
-	m_uintPixelCount = 0; 
-	m_SkipCounter = 0;
-
-	// Check for hardware occlusion support
-    if ( glDeleteOcclusionQueriesNV_ptr != 0 )	// This is a hack to see if hw occlusion is supported. pointer is 0 if it's not supported.
-	//if ( glDeleteQueriesARB_ptr != 0 )
-	{
-		m_bHWOcclusionSupport = true;
-	}
-	else
-	{
-		m_bHWOcclusionSupport = false;
-	}
-
-	if ( m_bHWOcclusionSupport )
-	{
-		glGenOcclusionQueriesNV_ptr( 1, m_uintQuery );	
-		//glGenQueriesARB_ptr(1, m_uintQuery);
-	}
-}
-
-
-//------------------------------------------------------------------
-GLHardwareOcclusionQuery::~GLHardwareOcclusionQuery() 
-{ 
-	if ( m_bHWOcclusionSupport )
-	{
-		glDeleteOcclusionQueriesNV_ptr( 1, &m_uintQuery[0] );  
-		//glDeleteQueriesARB_ptr(1, &m_uintQuery[0]);
-	}	
-}
-
-//------------------------------------------------------------------
-void GLHardwareOcclusionQuery::beginOcclusionQuery() 
-{ 
-	if ( m_bHWOcclusionSupport )	// Make it fail silently if hardware occlusion isn't supported
-	{
-		// do the actual occlusion query for this node
-		glBeginOcclusionQueryNV_ptr( m_uintQuery[0] );
-		//glBeginQueryARB_ptr(GL_SAMPLES_PASSED_ARB, m_uintQuery[0]);
-	}
-}
-	
-void GLHardwareOcclusionQuery::endOcclusionQuery() 
-{ 
-	if ( m_bHWOcclusionSupport )	// Make it fail silently if hardware occlusion isn't supported
-	{
-		glEndOcclusionQueryNV_ptr();
-		//glEndQueryARB_ptr(GL_SAMPLES_PASSED_ARB);
-	}
-}
-//------------------------------------------------------------------
-bool GLHardwareOcclusionQuery::pullOcclusionQuery( unsigned int * NumOfFragments, const bool waitForResult) 
+#ifdef GTP_VISIBILITY_MODIFIED_OGRE
+	//------------------------------------------------------------------
+	bool GLHardwareOcclusionQuery::pullOcclusionQuery( unsigned int * NumOfFragments, const bool waitForResult, const HW_OCCLUSIONQUERY flag) 
 {
 	unsigned int isAvailable = GL_TRUE;
-	//int isAvailable = GL_TRUE;
 
-	if( m_bHWOcclusionSupport )	
+		if (mHasOcclusionSupport)	
 	{
 		if (!waitForResult)
 		{
-			glGetOcclusionQueryuivNV_ptr( m_uintQuery[0], GL_PIXEL_COUNT_AVAILABLE_NV, &isAvailable );
-			//glGetQueryivARB_ptr(m_uintQuery[0], GL_QUERY_RESULT_AVAILABLE_ARB, &isAvailable);
+			// use nv queries rather that arb because they are faster (no flush)
+				//glGetQueryivARB_ptr(mQueryID, GL_QUERY_RESULT_AVAILABLE_ARB, &isAvailable);
+				glGetOcclusionQueryuivNV_ptr(mQueryID, GL_PIXEL_COUNT_AVAILABLE_NV, &isAvailable);
 		}
 
 		if (isAvailable == GL_TRUE)
 		{
-			glGetOcclusionQueryuivNV_ptr( m_uintQuery[0], GL_PIXEL_COUNT_NV, NumOfFragments );
-			//glGetQueryObjectuivARB_ptr( m_uintQuery[0], GL_QUERY_RESULT_ARB, NumOfFragments);
+				//glGetQueryObjectuivARB_ptr(mQueryID, GL_QUERY_RESULT_ARB, NumOfFragments);
+				glGetOcclusionQueryuivNV_ptr(mQueryID, GL_PIXEL_COUNT_NV, NumOfFragments);
 		}
 	} 
@@ -234,19 +169,9 @@
 	}
 
-	m_uintPixelCount = *NumOfFragments; 
+		mPixelCount = *NumOfFragments; 
 
 	return isAvailable == GL_TRUE;	
 }
 
-//------------------------------------------------------------------
-bool GLHardwareOcclusionQuery::pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult, const HW_OCCLUSIONQUERY flag  ) 
-{
-	return pullOcclusionQuery(NumOfFragments, waitForResult);
+#endif // GTP_VIBILITY_MODIFIED_OGRE
 }
-
-#endif // GTP_VISIBILITY_MODIFIED_OGRE
-
-
-}
-
-
Index: trunk/VUT/work/ogre_changes/RenderSystems/GL/src/OgreGLRenderSystem.cpp
===================================================================
--- trunk/VUT/work/ogre_changes/RenderSystems/GL/src/OgreGLRenderSystem.cpp	(revision 97)
+++ trunk/VUT/work/ogre_changes/RenderSystems/GL/src/OgreGLRenderSystem.cpp	(revision 115)
@@ -58,4 +58,5 @@
 GL_ClientActiveTextureARB_Func glClientActiveTextureARB_ptr;
 GL_SecondaryColorPointerEXT_Func glSecondaryColorPointerEXT_ptr;
+GL_SecondaryColor3fEXT_Func glSecondaryColor3fEXT_ptr;
 GL_GenBuffersARB_Func glGenBuffersARB_ptr;
 GL_BindBufferARB_Func glBindBufferARB_ptr;
@@ -97,15 +98,13 @@
 GL_EndOcclusionQueryNV_Func glEndOcclusionQueryNV_ptr;
 GL_GetOcclusionQueryuivNV_Func glGetOcclusionQueryuivNV_ptr;
- 
-#ifdef GTP_VISIBILITY_MODIFIED_OGRE
 GL_GenQueriesARB_Func glGenQueriesARB_ptr;
 GL_DeleteQueriesARB_Func glDeleteQueriesARB_ptr;
-GL_IsQueryARB_Func glIsQueryARB_ptr;
 GL_BeginQueryARB_Func glBeginQueryARB_ptr;
 GL_EndQueryARB_Func glEndQueryARB_ptr;
+#ifdef GTP_VISIBILITY_MODIFIED_OGRE
 GL_GetQueryivARB_Func glGetQueryivARB_ptr;
 GL_GetQueryObjectivARB_Func glGetQueryObjectivARB_ptr;
+#endif // GTP_VISIBILITY_MODIFIED_OGRE
 GL_GetQueryObjectuivARB_Func glGetQueryObjectuivARB_ptr;
-#endif // GTP_VISIBILITY_MODIFIED_OGRE
 
 namespace Ogre {
@@ -191,4 +190,5 @@
         glClientActiveTextureARB_ptr = 0;
         glSecondaryColorPointerEXT_ptr = 0;
+        glSecondaryColor3fEXT_ptr = 0;
         glGenBuffersARB_ptr = 0;
         glBindBufferARB_ptr = 0;
@@ -220,15 +220,13 @@
         glEndOcclusionQueryNV_ptr = 0;
         glGetOcclusionQueryuivNV_ptr = 0;
-
-#ifdef GTP_VISIBILITY_MODIFIED_OGRE
 		glGenQueriesARB_ptr = 0;
 		glDeleteQueriesARB_ptr = 0;
-		glIsQueryARB_ptr = 0;
 		glBeginQueryARB_ptr = 0;
 		glEndQueryARB_ptr = 0;
+#ifdef GTP_VISIBILITY_MODIFIED_OGRE
 		glGetQueryivARB_ptr = 0;
 		glGetQueryObjectivARB_ptr = 0;
+#endif // GTP_VISIBILITY_MODIFIED_OGRE
 		glGetQueryObjectuivARB_ptr = 0;
-#endif // GTP_VISIBILITY_MODIFIED_OGRE
 
         mCurrentLights = 0;
@@ -543,4 +541,6 @@
         glSecondaryColorPointerEXT_ptr = 
             (GL_SecondaryColorPointerEXT_Func)mGLSupport->getProcAddress("glSecondaryColorPointerEXT");
+        glSecondaryColor3fEXT_ptr = 
+            (GL_SecondaryColor3fEXT_Func)mGLSupport->getProcAddress("glSecondaryColor3fEXT");
         glGenBuffersARB_ptr = 
             (GL_GenBuffersARB_Func)mGLSupport->getProcAddress("glGenBuffersARB");
@@ -622,26 +622,21 @@
         glGetOcclusionQueryuivNV_ptr =
             (GL_GetOcclusionQueryuivNV_Func)mGLSupport->getProcAddress("glGetOcclusionQueryuivNV");
-		glGetQueryObjectivARB_ptr = 
-			 (GL_GetQueryObjectivARB_Func)mGLSupport->getProcAddress("glGetQueryObjectivARB");
-		glGetQueryObjectuivARB_ptr = 
-			 (GL_GetQueryObjectuivARB_Func)mGLSupport->getProcAddress("glGetQueryObjectuivARB");
-#ifdef GTP_VISIBILITY_MODIFIED_OGRE
+
 		glGenQueriesARB_ptr = 
 			 (GL_GenQueriesARB_Func)mGLSupport->getProcAddress("glGenQueriesARB");
 		glDeleteQueriesARB_ptr =
 			(GL_DeleteQueriesARB_Func)mGLSupport->getProcAddress("glDeleteQueriesARB");
-		glIsQueryARB_ptr =
-			(GL_IsQueryARB_Func)mGLSupport->getProcAddress("glIsQueryARB");
 		glBeginQueryARB_ptr =
 			 (GL_BeginQueryARB_Func)mGLSupport->getProcAddress("glBeginQueryARB");
 		glEndQueryARB_ptr =
 			 (GL_EndQueryARB_Func)mGLSupport->getProcAddress("glEndQueryARB");
+	#ifdef GTP_VISIBILITY_MODIFIED_OGRE
 		glGetQueryivARB_ptr = 
 			(GL_GetQueryivARB_Func)mGLSupport->getProcAddress("glGetQueryivARB");
 		glGetQueryObjectivARB_ptr = 
 			 (GL_GetQueryObjectivARB_Func)mGLSupport->getProcAddress("glGetQueryObjectivARB");
+	#endif // GTP_VISIBILITY_MODIFIED_OGRE
 		glGetQueryObjectuivARB_ptr = 
 			 (GL_GetQueryObjectuivARB_Func)mGLSupport->getProcAddress("glGetQueryObjectuivARB");
-#endif // GTP_VISIBILITY_MODIFIED_OGRE
 
         mCapabilities->log(LogManager::getSingleton().getDefaultLog());
@@ -1857,4 +1852,6 @@
 		    cv1[2] = bm.colourArg1.b;
 		    cv1[3] = bm.colourArg1.a;
+			mManualBlendColours[stage][0] = bm.colourArg1;
+
 
 		    cv2[0] = bm.colourArg2.r;
@@ -1862,16 +1859,17 @@
 		    cv2[2] = bm.colourArg2.b;
 		    cv2[3] = bm.colourArg2.a;
+			mManualBlendColours[stage][1] = bm.colourArg2;
         }
 
 		if (bm.blendType == LBT_ALPHA)
         {
-		    cv1[0] = 0;
-		    cv1[1] = 0;
-		    cv1[2] = 0;
+		    cv1[0] = mManualBlendColours[stage][0].r;
+		    cv1[1] = mManualBlendColours[stage][0].g;
+		    cv1[2] = mManualBlendColours[stage][0].b;
 		    cv1[3] = bm.alphaArg1;
 
-		    cv2[0] = 0;
-		    cv2[1] = 0;
-		    cv2[2] = 0;
+		    cv2[0] = mManualBlendColours[stage][1].r;
+		    cv2[1] = mManualBlendColours[stage][1].g;
+		    cv2[2] = mManualBlendColours[stage][1].b;
 		    cv2[3] = bm.alphaArg2;
         }
@@ -2249,4 +2247,5 @@
         }
         glColor4f(1,1,1,1);
+        glSecondaryColor3fEXT_ptr(0.0f, 0.0f, 0.0f);
 
         // UnGuard
@@ -2537,4 +2536,6 @@
         glLightModeli(GL_LIGHT_MODEL_COLOR_CONTROL, GL_SEPARATE_SPECULAR_COLOR);
         glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, 1);        
+        glEnable(GL_COLOR_SUM);
+
         // Check for FSAA
         // Enable the extension if it was enabled by the GLSupport
Index: trunk/VUT/work/ogre_changes/RenderSystems/Direct3D9/include/OgreD3D9HardwareOcclusionQuery.h
===================================================================
--- trunk/VUT/work/ogre_changes/RenderSystems/Direct3D9/include/OgreD3D9HardwareOcclusionQuery.h	(revision 92)
+++ trunk/VUT/work/ogre_changes/RenderSystems/Direct3D9/include/OgreD3D9HardwareOcclusionQuery.h	(revision 115)
@@ -33,8 +33,6 @@
 namespace Ogre {
 
-
-
 // If you use multiple rendering passes you can test only the first pass and all other passes don't have to be rendered 
-// if the first pass resultet has too few pixels visable.
+	// if the first pass resultet has too few pixels visible.
 
 // Be sure to render all occlluder first and whats out so the RenderQue don't switch places on 
@@ -46,4 +44,6 @@
   *
   * @author Lee Sandberg, email lee@abcmedia.se
+	*
+	* Updated on 12/7/2004 by Chris McGuirk
   */
 class D3D9HardwareOcclusionQuery : public HardwareOcclusionQuery
@@ -71,35 +71,27 @@
 	void beginOcclusionQuery();	
 	void endOcclusionQuery();
+		bool pullOcclusionQuery( unsigned int* NumOfFragments, const HW_OCCLUSIONQUERY flag = HWOCCLUSIONQUERY_FLUSH);
+		unsigned int getLastQuerysPixelcount() { return mPixelCount; }
 
-#ifdef GTP_VISIBILITY_MODIFIED_OGRE
-	bool pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult,
-							 const HW_OCCLUSIONQUERY flag  ); 
-	bool pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult );
-#else
-	bool pullOcclusionQuery( unsigned int* NumOfFragments );
-	bool pullOcclusionQuery( unsigned int* NumOfFragments, const HW_OCCLUSIONQUERY flag  ); 
-#endif // GTP_VISIBILITY_MODIFIED_OGRE
-
-	unsigned int getLastQuerysPixelcount() { return m_uintPixelCount; }
-	
-	// This functions are optional, it's a simple filter that simply skips some hardware occlusion tests on visable objects only
-	// It's easy to use if you don't have to keep track on which objects are visable (can be skipped) and what objects arn't visable..
-	// (None visable objects and object you introduce for the first time have allways to be tested allthough the cheepest possible 
-	// LOD (Level Of Detail) mesh and material wize). 
+		// These functions are optional, it's a simple filter that simply skips some hardware occlusion tests on visible objects only
+		// It's easy to use if you don't have to keep track of which objects are visible (can be skipped) and what objects arn't visible..
+		// (None visible objects and object you introduce for the first time have always to be tested although the cheapest possible 
+		// LOD (Level Of Detail) mesh and material-wise). 
 
 	/**
 	  *   
-	  * Remarks This function allows you to set how often the hardware occlusion really are sent to the driver
+		* Remarks This function allows you to set how often the hardware occlusion query is sent to the driver
 	  * if you set it to 0 every hw occlusion test is acctually made. If you set it to 1 only the half of your queries are sent 
-	  * for all visable objects. 2 will result in 25% of all queries to acctualy be sent. 
-	  * New and none visable objects will be tested all the time.
-	  * This functionality is here because this class can keep track on visable and none visable objects for you.
+		* 2 will result in 25% of all queries to acctualy be sent. 
+		* This functionality is here because this class can keep track on visible and none visible objects for you.
 	  * Once you you set the SkipRate for any hardware occlusion instance it effects all others.
 	  */
 
+		void setSkipRate( int skip ) { mSkipInterval = skip; }			// Using 2 only 50 % of the tests are actully made and 3 results in only 33% of the tests. So on.
+		int	 getSkipRate() { return mSkipInterval; } 
 
-	void setSkipRate( int skip ) { m_Skip = skip; }			// Using 2 only 50 % of the tests are actually made and 3 results in only 33% of the tests. So on.
-	int	 getSkipRate() { return m_Skip; } 
-
+#ifdef GTP_VISIBILITY_MODIFIED_OGRE
+	bool pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult, const HW_OCCLUSIONQUERY flag = HWOCCLUSIONQUERY_FLUSH ); 
+#endif // GTP_VISIBILITY_MODIFIED_OGRE
 //----------------------------------------------------------------------
 // Protected members
@@ -107,14 +99,10 @@
 protected:
 
-	bool pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult, 
-						     const DWORD queryFlag );
-
-	unsigned int		m_uintPixelCount;		
-	IDirect3DQuery9*	m_pD3DQuery;
-	IDirect3DDevice9*   m_pD3DDevice;       // d3d device
-	bool				m_bOcclusionQuery;
-	int					m_SkipCounter;		// m_SkipConter =  m_SkipConter % m_Skip; if ( m_SkipConter == 0 && m_uintPixelCount !=0 ) TestHWOcclusion else just return 
-	static int			m_Skip;				// This is shared by all instancies
-	bool				m_bHWOcclusionSupport;
+		unsigned int		mPixelCount;		
+		IDirect3DQuery9*	mpQuery;
+		IDirect3DDevice9*   mpDevice;
+		int					mSkipCounter;
+		int					mSkipInterval;
+		bool				mHasOcclusionSupport;
 };
 
Index: trunk/VUT/work/ogre_changes/RenderSystems/Direct3D9/src/OgreD3D9HardwareOcclusionQuery.cpp
===================================================================
--- trunk/VUT/work/ogre_changes/RenderSystems/Direct3D9/src/OgreD3D9HardwareOcclusionQuery.cpp	(revision 97)
+++ trunk/VUT/work/ogre_changes/RenderSystems/Direct3D9/src/OgreD3D9HardwareOcclusionQuery.cpp	(revision 115)
@@ -29,6 +29,4 @@
 namespace Ogre {
 
-int D3D9HardwareOcclusionQuery::m_Skip = 0;
-
 /**
   * This is a class that is the DirectX9 implementation of 
@@ -36,30 +34,31 @@
   *
   * @author Lee Sandberg
+	*
+	* Updated on 12/7/2004 by Chris McGuirk
   */
 
 /**
   * Default object constructor
-  * 
   */
 D3D9HardwareOcclusionQuery::D3D9HardwareOcclusionQuery( IDirect3DDevice9* pD3DDevice ) 
 { 
-	m_pD3DDevice = pD3DDevice;
-	m_uintPixelCount = 0; 
-	m_SkipCounter = 0;
-	m_bHWOcclusionSupport = false;
+		mpDevice = pD3DDevice;
+		mPixelCount = 0; 
+		mSkipCounter = 0;
+		mSkipInterval = 0;
+		mHasOcclusionSupport = false;
 
-	HRESULT hr = m_pD3DDevice->CreateQuery(D3DQUERYTYPE_OCCLUSION, &m_pD3DQuery);
+		// create the occlusion query
+		HRESULT hr = mpDevice->CreateQuery(D3DQUERYTYPE_OCCLUSION, &mpQuery);
+
 	if ( hr != D3D_OK ) 
 	{
-		//OGRE_EXCEPT(hr, "D3D9HardwareOcclusionQuery couldn't create hardware occlusion query object.", 
-        //        "D3D9HardwareOcclusionQuery::D3D9HardwareOcclusionQuery");
-		m_bHWOcclusionSupport = false;
+			mHasOcclusionSupport = false;
 	}
 	else 
 	{
-		m_bHWOcclusionSupport = true;
+			mHasOcclusionSupport = true;
 	}
 }
-
 
 /**
@@ -68,8 +67,7 @@
 D3D9HardwareOcclusionQuery::~D3D9HardwareOcclusionQuery() 
 { 
-	SAFE_RELEASE( m_pD3DQuery ); 
+		SAFE_RELEASE(mpQuery); 
 }
 
-#ifndef GTP_VISIBILITY_MODIFIED_OGRE
 //------------------------------------------------------------------
 // Occlusion query functions (see base class documentation for this)
@@ -77,61 +75,45 @@
 void D3D9HardwareOcclusionQuery::beginOcclusionQuery() 
 { 
-	if( m_bHWOcclusionSupport )		// Make it fail silently if hardware occlusion isn't supported
+		// Make it fail silently if hardware occlusion isn't supported
+		if(mHasOcclusionSupport)
 	{
-		if  ( m_SkipCounter ==  m_Skip ) { m_SkipCounter = 0; };		// Counter starts at 0 again at m_Skip 
-		
-		if ( m_SkipCounter == 0 && m_uintPixelCount != 0 )	// New or none visable objects must allways be tested but visable objects can be skiped
+#ifndef GTP_VISIBILITY_MODIFIED_OGRE
+			// Counter starts at 0 again at mSkipInterval 
+			if(mSkipCounter == mSkipInterval) 
+#else
+			if (mSkipCounter >= mSkipInterval)  // otherwise no query ever issued if mSkipInterval = 0 !
+#endif // GTP_VISIBILITY_MODIFIED_OGRE
 		{
-			m_pD3DQuery->Issue(D3DISSUE_BEGIN); 
+				mSkipCounter = 0; 
+}
+			//std::stringstream d; d << "count: " << mSkipCounter;
+			//LogManager::getSingleton().logMessage(d.str());
+			if (mSkipCounter == 0)
+		{
+				mpQuery->Issue(D3DISSUE_BEGIN); 
 		}
 	}
+	
 }
-	
-void D3D9HardwareOcclusionQuery::endOcclusionQuery() 
-{ 
-	if( m_bHWOcclusionSupport )	// Make it fail silently if hardware occlusion isn't supported
+
+	void D3D9HardwareOcclusionQuery::endOcclusionQuery() 
 	{
-		if (m_SkipCounter == 0 && m_uintPixelCount != 0 ) // New or none visable objects must allways be tested but visable objects can be skiped
-		{
-			m_pD3DQuery->Issue(D3DISSUE_END); 
-		}
-		m_SkipCounter++;								 // The skip counter is increased 
+		// Make it fail silently if hardware occlusion isn't supported
+		if(mHasOcclusionSupport)
+			{
+			if(mSkipCounter == 0)
+			{ 
+				mpQuery->Issue(D3DISSUE_END); 
+	}
+
+			// The skip counter is increased
+			mSkipCounter++; 
 	}
 }
 
 //------------------------------------------------------------------
-// This version of pullOcclusionQuery cases the DX9 API/Driver to flush all commands to the 3D card
-// to allow a fast result from the query, but at the cost of poorer batching of API calls to the card.
-// Note: OpenGL dosn't use this flag at all so the application running OpenGL won't display any different behaviour.
-//--
-bool D3D9HardwareOcclusionQuery::pullOcclusionQuery( unsigned int* NumOfFragments) 
-{
-	HRESULT hr;
-	
-	if( m_bHWOcclusionSupport )	// Make it fail silently if hardware occlusion isn't supported
-	{
-		hr = m_pD3DQuery->GetData( NumOfFragments, sizeof( NumOfFragments ), D3DGETDATA_FLUSH );
-
-		if ( hr != S_OK ) 
-			{
-				return false; 
-			}
-			else 
-			{ 
-				m_uintPixelCount = *NumOfFragments; 
-				return true; 
-			}
-	}
-	else
-	{
-		m_uintPixelCount = 100000; // Fails quitlly if hardware occlusion is not supported - every object is visable
-		return true;
-	}
-}
-
-//------------------------------------------------------------------
-// This version of pullOcclusionQuery cases the DX9 API/Driver to not flush all commands to the 3D card
+	// This version of pullOcclusionQuery causes the DX9 API/Driver to not flush all commands to the 3D card
 // to allow a fast result from the query, but the batching of API calls to the card will be normal. 
-// But the query wont be processed until the card recives the query in the nexr batch.
+	// But the query wont be processed until the card recives the query in the next batch.
 // Note: OpenGL dosn't use this flag at all so the application running OpenGL won't display any different behaviour.
 //--
@@ -140,97 +122,52 @@
 	HRESULT hr;
 
-	// TO DO: USE lockOpts= D3D9Mappings::get(options); instead of RS_OCCLUSIONQUERY enum
+		// Make it fail silently if hardware occlusion isn't supported
+		if(mHasOcclusionSupport)
+	{
+			DWORD d3dFlags = (flag == HWOCCLUSIONQUERY_FLUSH) ? D3DGETDATA_FLUSH : 0;
+	
+			// run until success (http://www.gamedev.net/reference/programming/features/occlusionculling/page2.asp)
+			while(hr = mpQuery->GetData( NumOfFragments, sizeof( NumOfFragments ), d3dFlags) == S_FALSE);
 
-	if( m_bHWOcclusionSupport )	// Make it fail silently if hardware occlusion isn't supported
-	{
-	
-		switch( flag )
-		{
-			case HWOCCLUSIONQUERY_FLUSH : 	
-				hr = m_pD3DQuery->GetData( NumOfFragments, sizeof( NumOfFragments ), D3DGETDATA_FLUSH );
-			break;
-
-			case HWOCCLUSIONQUERY_NOFLUSH :	
-				hr = m_pD3DQuery->GetData( NumOfFragments, sizeof( NumOfFragments ), 0 );
-			break;
-		};
-
-
-
-		if ( hr != S_OK ) 
-			{
-				return false; 
+			mPixelCount = *NumOfFragments;
 			}
 			else 
 			{ 
-				m_uintPixelCount = *NumOfFragments; 
-				return true; 
+			// fail silently if not supported, assume visible i suppose
+			mPixelCount = 100000;
 			}
-	}
-	else 
-	{
-		m_uintPixelCount = 100000; // Fails quitlly if hardware occlusion is not supported - every object is visable
+
 		return true;
 	}
-}
-#else // GTP_VISIBILITY_MODIFIED_OGRE
+
+#ifdef GTP_VISIBILITY_MODIFIED_OGRE
 //------------------------------------------------------------------
-void D3D9HardwareOcclusionQuery::beginOcclusionQuery() 
-{ 
-	if( m_bHWOcclusionSupport )		// Make it fail silently if hardware occlusion isn't supported
+	bool D3D9HardwareOcclusionQuery::pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult, 
+													     const HW_OCCLUSIONQUERY flag ) 
 	{
-		m_pD3DQuery->Issue(D3DISSUE_BEGIN); 
+		HRESULT hr = S_OK;
+		DWORD queryFlag = (flag == HWOCCLUSIONQUERY_FLUSH) ? D3DGETDATA_FLUSH : 0;
+
+		if (mHasOcclusionSupport)	// In case hardware occlusion isn't supported
+		{	
+			do
+			{
+				hr = mpQuery->GetData(NumOfFragments, sizeof(NumOfFragments), queryFlag);
+	    	}
+			while(waitForResult && (hr == S_FALSE));
+		
+			mPixelCount = *NumOfFragments;
+		}
+		else
+		{
+			mPixelCount = 100000; // every object is visible
+		}
+	
+		return hr == S_OK;
 	}
-}
-//------------------------------------------------------------------
-void D3D9HardwareOcclusionQuery::endOcclusionQuery() 
-{ 
-	if( m_bHWOcclusionSupport )	// Make it fail silently if hardware occlusion isn't supported
-	{
-		m_pD3DQuery->Issue(D3DISSUE_END); 
-	}
-}
-//------------------------------------------------------------------
-bool D3D9HardwareOcclusionQuery::pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult ) 
-{
-	return pullOcclusionQuery(NumOfFragments, waitForResult, HWOCCLUSIONQUERY_FLUSH);
-}
-
-//------------------------------------------------------------------
-bool D3D9HardwareOcclusionQuery::pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult, 
-												     const HW_OCCLUSIONQUERY flag  ) 
-{
-	DWORD queryFlag = flag == HWOCCLUSIONQUERY_FLUSH ? D3DGETDATA_FLUSH : 0;
-	// TO DO: USE lockOpts= D3D9Mappings::get(options); instead of RS_OCCLUSIONQUERY enum
-
-	return pullOcclusionQuery(NumOfFragments, waitForResult, queryFlag);
-}
-
-//------------------------------------------------------------------
-bool D3D9HardwareOcclusionQuery::pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult, 
-												     const DWORD queryFlag ) 
-{
-	HRESULT hr = S_OK;
-
-	if( m_bHWOcclusionSupport )	// In case hardware occlusion isn't supported
-	{	
-		do
-		{
-			hr = m_pD3DQuery->GetData( NumOfFragments, sizeof( NumOfFragments ), queryFlag );
-	    	}
-		while(waitForResult && (hr == S_FALSE));
-		
-		m_uintPixelCount = *NumOfFragments; 
-	}
-	else
-	{
-		m_uintPixelCount = 100000; // every object is visible
-	}
-	
-	return hr == S_OK;
-}
 
 
 #endif // GTP_VISIBILITY_MODIFIED_OGRE
 
-} // namespace OGre
+
+}
Index: trunk/VUT/work/TestCulling/TestCulling.vcproj
===================================================================
--- trunk/VUT/work/TestCulling/TestCulling.vcproj	(revision 107)
+++ trunk/VUT/work/TestCulling/TestCulling.vcproj	(revision 115)
@@ -13,5 +13,5 @@
 		<Configuration
 			Name="Debug|Win32"
-			OutputDirectory=".\bin\$(ConfigurationName)"
+			OutputDirectory=".\lib\$(ConfigurationName)"
 			IntermediateDirectory=".\obj\$(ConfigurationName)"
 			ConfigurationType="1"
@@ -21,5 +21,5 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\include&quot;;&quot;$(OGRE_ADDONS_PATH)\dotsceneoctree\PlugIns\DotSceneManager\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;../include;../../GtpVisibility/include"
+				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\include&quot;;&quot;$(OGRE_ADDONS_PATH)\dotsceneoctree\PlugIns\DotSceneManager\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;../include;../../GtpVisibility/include;../../Ogre/include"
 				PreprocessorDefinitions="_WINDOWS;_STLP_USE_DYNAMIC_LIB;OGRE_LIBRARY_IMPORTS;_DEBUG;WIN32;_STLP_DEBUG;PLUGIN_TERRAIN_IMPORTS;GTP_VISIBILITY_MODIFIED_OGRE"
 				MinimalRebuild="TRUE"
@@ -34,8 +34,8 @@
 			<Tool
 				Name="VCLinkerTool"
-				AdditionalDependencies="Plugin_OctreeSceneManager.lib OGREMain_d.LIB CEGUIBase_d.lib OgreGUIRenderer_d.lib Plugin_DotSceneManager.lib"
+				AdditionalDependencies="Plugin_OctreeSceneManager.lib OGREMain_d.LIB CEGUIBase_d.lib OgreGUIRenderer_d.lib Plugin_DotSceneManager.lib Plugin_VisibilitySceneManager.lib"
 				OutputFile="$(OGRE_PATH)/Samples/Common/bin/Debug/TestCulling.exe"
 				LinkIncremental="2"
-				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\Dependencies\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_ADDONS_PATH)\dotsceneoctree\PlugIns\DotSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\OgreMain\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;"
+				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\Dependencies\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_ADDONS_PATH)\dotsceneoctree\PlugIns\DotSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\OgreMain\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;&quot;$(GAMETOOLS_PATH)\trunk\VUT\Ogre\lib\$(ConfigurationName)&quot;"
 				GenerateDebugInformation="TRUE"
 				ProgramDatabaseFile="$(OutDir)/TestCulling.pdb"
